/*!
 * @file bounding_sphere.h
  *  Definition of a bounding sphere

*/

#ifndef _BOUNDING_SPHERE_H
#define _BOUNDING_SPHERE_H

#include "base_object.h"
#include "bounding_volume.h"


//! A class representing an extended bounding volume tree: an sphere
class BoundingSphere : public BoundingVolume {
  ObjectListDeclaration(BoundingSphere);

 public:
  BoundingSphere();
  virtual ~BoundingSphere();

  inline const float getRadius () const { return this->radius; }

 private:
  float radius;
};

#endif /* _BOUNDING_SPHERE_H */
