/*
   orxonox - the future of 3D-vertical-scrollers

   Copyright (C) 2004 orx

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

### File Specific:
   main-programmer: Patrick Boenzli
*/

#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_IMPORTER

#include "md3_animation.h"



namespace md3
{



  MD3AnimationMap MD3Animation::animationList[25] = {
    { "Death 1",                 BOTH  },
    { "Dead 1",                  BOTH  },
    { "Death 2",                 BOTH  },
    { "Dead 2",                  BOTH  },
    { "Death 3",                 BOTH  },
    { "Dead 3",                  BOTH  },
    { "Gesture",                 BOTH  },
    { "Shoot",                   TORSO },
    { "Hit",                     TORSO },
    { "Drop Weapon",             TORSO },
    { "Raise Weapon",            TORSO },
    { "Stand With Weapon",       TORSO },
    { "Stand with Gauntlet",     TORSO },
    { "Crouched Walk",           LEGS  },
    { "Walk",                    LEGS  },
    { "Run",                     LEGS  },
    { "Backpedal",               LEGS  },
    { "Swim",                    LEGS  },
    { "Jump Forward",            LEGS  },
    { "Land Forward",            LEGS  },
    { "Jump Backward",           LEGS  },
    { "Land Backward",           LEGS  },
    { "Stand Idle",              LEGS  },
    { "Crouched Idle",           LEGS  },
    { "Turn In Place",           LEGS  }
  };


  /**
   * create an empty MD3Animation object
   */
  MD3Animation::MD3Animation()
  {
    this->init();
  }


  /**
   * deconstructor
   */
  MD3Animation::~MD3Animation()
  {}


  void MD3Animation::init()
  {
    this->first = 0;
    this->numFrames = 0;
    this->fps = 0;
  }


}

