/*!
 * @file single_player_world.h
 *  Holds and manages all single player game data
 */

#ifndef _SINGLE_PLAYER_WORLD_H
#define _SINGLE_PLAYER_WORLD_H


#include "game_world.h"


class TiXmlElement;
class SinglePlayerWorldData;


//! The game world
/**
 *  this class initializes everything that should be displayed inside of the current level.
 *  it is the main driving factor during gameplay.
 */
class SinglePlayerWorld : public GameWorld
{
  ObjectListDeclaration(SinglePlayerWorld);

  public:
    SinglePlayerWorld (const TiXmlElement* root = NULL);
    virtual ~SinglePlayerWorld ();

    virtual void loadParams(const TiXmlElement* root);
};

#endif /* _SINGLE_PLAYER_WORLD_H */
