/*!
 * @file character_attributes.h
 * Definition of the attributes of a character (healt, armor,.. ) whatever is important to the character
 */

#ifndef _CHARACTER_ATTRIBUTES_H
#define _CHARACTER_ATTRIBUTES_H

#include "base_object.h"


//! A class including all important information about a character
/**
  its not yet clear, what the character-attributes will be.
*/
class CharacterAttributes : public BaseObject {
    ObjectListDeclaration(CharacterAttributes);

 public:
  CharacterAttributes();
  virtual ~CharacterAttributes();

  /* health */
  void setHealth(int health);
  int addHealth(int health);
  bool substractHealth(int health);
  int getHealth();

  void setHealthMax(int healthMax);
  int getHealthMax();


  /* armor/ shields */
  void setShieldStrength(int shieldStrength);
  void addShieldStrength(int shiledStrength);
  int substractShieldStrength(int shieldStrength);
  int getShieldStrength();


  /* damage */
  void setDamageToAirCraft(int damage);
  int getDamageToAirCraft();

  void setDamageToGroundCraft(int damage);
  int getDamageToGroundCraft();

  void setDamageLaserModifier(float modifier);
  float getDamageLaserModifier();

  void setDamagePlasmaModifier(float modifier);
  float getDamagePlasmaModifier();

  void setDamageExplosiveModifier(float modifier);
  float getDamageExplosiveModifier();


  /* energy */
  void setEnergy(int energy);
  int addEnergy(int addEnergy);
  bool substractEnergy(int subEnergy);
  int getEnergy();

  void setEnergyConsumption(int energy);
  int getEnergyConsumption();

  void setEnergyMax(int energy);
  int getEnergyMax();


 private:
  /* healt */
  int health;                        //<! the healt of a projectile
  int healthMax;                     //<! the max healt of a projectile, =0 if no limit

  /* armor/ shields */
  int shieldStrength;                //<! the shiled strength of a character, =0 if no shields

  /* damage */
  int damageToAirCraft;              //<! damage dealt to a air craft in case of a hit
  int damageToGroundCraft;           //<! damage dealt to a ground craft in case of a hit

  float damageLaserModifier;         //<! [0..1] the damage from laser is multiplied with this modifier. there can be things in the world, that are immune to certain damage
  float damagePlasmaModifier;        //<! [0..1] the damage from plasma is multiplied with this modifier. there can be things in the world, that are immune to certain damage
  float damageExplosiveModifier;      //<! [0..1] the damage from exposives (rockets, tnt,...) is multiplied with this modifier. there can be things in the world, that are immune to certain damage

  /* energy */
  int energyConsumption;             //<! if the character defines an action, it will consume energy
  int energy;                        //<! the current amount of energy saved in this part
  int energyMax;                     //<! the maximal energy a character can handle
};

#endif /* _CHARACTER_ATTRIBUTES_H */
