/*!
 * @file text_element.h
 *  Definition of an TextElement
 */

#ifndef _TEXT_ELEMENT_H
#define _TEXT_ELEMENT_H

#include "p_node.h"
#include "text.h"
#include "event_listener.h"

#include "vector.h"


// FORWARD DECLARATION
class Model;
class Material;
class TiXmlElement;

//! A class that enables the
class TextElement : public Text {
  ObjectListDeclaration(TextElement);

 public:
  TextElement(const TiXmlElement* root = NULL);
  virtual ~TextElement();

  void init();
  virtual void loadParams(const TiXmlElement* root);

  void setText(const std::string& text);
  void setFont(const std::string& font);

 private:

};

#endif /* _TEXT_ELEMENT_H */
