/*!
 * @file model_entity.h
 *  Definition of the ModelEntity, that handles the Display of an atmosphere for orxonox.
 */

#ifndef _MODEL_ENTITY_H
#define _MODEL_ENTITY_H

/* INCLUDES */
#include "world_entity.h"

/* FORWARD DECLARATION */

//! A Class to handle a ModelEntity
class ModelEntity : public WorldEntity
{
  ObjectListDeclaration(ModelEntity);
 public:
  ModelEntity(const TiXmlElement* root);

  virtual ~ModelEntity();

  virtual void loadParams(const TiXmlElement* root);

  void setSpeed(float x, float y, float z);
  void setMomentum (float angle, float x, float y, float z);

  virtual void tick(float dt);

  private:
    Vector*           speed;
    Quaternion*       momentum;
};

#endif  /* _MODEL_ENTITY_H */



