#ifndef _MOUNT_POINT_H
#define _MOUNT_POINT_H

#include "world_entity.h"

class TiXmlElement;


class MountPoint : public WorldEntity
{
    ObjectListDeclaration(MountPoint);

  public:
    MountPoint ();
    MountPoint(const TiXmlElement* root);
    virtual ~MountPoint ();

    void init();
    virtual void loadParams(const TiXmlElement* root);


    virtual void tick (float time);
    virtual void draw() const;

    void debugDraw() const;


    void mount(WorldEntity* entity);
    void unmount();


  private:
    WorldEntity*         _mount;       //!< the entity mounted at this mount point

};

#endif /* _MOUNT_POINT_H */
