/*!
 * @file network_turret.h
 * @brief description
*/

#ifndef _NETWORK_TURRET_H
#define _NETWORK_TURRET_H

#include "npcs/npc.h"

class AimingTurret;

//! A Class to ...
class NetworkTurret : public NPC
{
  ObjectListDeclaration(NetworkTurret);
public:
  NetworkTurret(const TiXmlElement* root = NULL);
  virtual ~NetworkTurret();

  virtual void loadParams(const TiXmlElement* root);

  virtual void postSpawn ();
  virtual void leftWorld ();


  virtual void destroy(WorldEntity* killer);

  virtual void draw() const;
  virtual void tick(float time);


  void setTargetGroup(int targetGroup);
  void setTargetGroupS(const std::string& targetGroup);

  virtual void varChangeHandler( std::list<int> & id );


private:
  void init();

private:
  PNode  weaponHolder;
  AimingTurret *weapon;

  int    targetGroup;
  int    targetGroup_write;

  int    targetGroup_handle;
};

#endif /* _NETWORK_TURRET_H */
