/*!
 * @file space_turret.h
 * @brief description
*/

#ifndef _SPACE_TURRET_H
#define _SPACE_TURRET_H

#include "npcs/npc.h"

#include <string>
#include <list>


class Weapon;

//! A Class to ...
class SpaceTurret : public NPC
{
  ObjectListDeclaration(SpaceTurret);

public:
  SpaceTurret(const TiXmlElement* root = NULL);
  virtual ~SpaceTurret();

  virtual void loadParams(const TiXmlElement* root);
  virtual void varChangeHandler( std::list< int > & id );


  void setWeaponLeft(const std::string& wLeft);
  void setWeaponRight(const std::string& wRight);

  virtual void postSpawn ();
  virtual void leftWorld ();

  virtual void destroy(WorldEntity* killer);

  virtual void draw() const;
  virtual void tick(float time);

private:
  void init();


private:
  PNode  weaponHolder[2];
  Weapon *left, *right;

  std::string wLeft;
  std::string wRight;
  int wLeftHandle;
  int wRightHandle;
};

#endif /* _SPACE_TURRET_H */
